package com.jah0wl.catan;

import javax.microedition.lcdui.Graphics;
//import com.nokia.mid.ui.FullCanvas;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.Canvas;
import java.util.Hashtable;
import java.util.Enumeration;
import com.jah0wl.catan.utils.*;
import com.jah0wl.catan.items.*;
import com.jah0wl.catan.fields.*;
import com.jah0wl.utils.*;

public class Board extends Canvas {
	public MapOfCatan map;
	private Hashtable vertices;
	private Hashtable edges;//aristasss
	private Robber robber;
	private Robber pirata;        // pirate, hacker
	private boolean isRobber = false;
	private boolean isPirata = false;

	private Rectangle bounds;

	// pruebas         //show/try   tests
	private boolean first=true;

	private Image buffImg;
	private Graphics buffGraphics;

    public Board(String s){
		super();

		robber = new Robber();
		pirata = new Robber();
		pirata.setValue(0);

		vertices = new Hashtable();
		edges = new Hashtable();

		map = new MapOfCatan(s);

		// El rea del tablero      // area of the board
		bounds=new Rectangle(map.getBounds().width,map.getBounds().height);

		// Inicializamos las imagenes // initialisation of images
		buffImg = Image.createImage(getWidth(),getHeight());
		buffGraphics = buffImg.getGraphics();
		paintIt(buffGraphics);
    }

    //! once and for all
    public void paintIt(Graphics g){
		// draw map
		// dibujamos el map
		map.paint(g);

        // draw robber/pirate
        // dibujamos el robber/pirata
		if (isRobber) robber.paint(g);
		if (isPirata) pirata.paint(g);

		// dibujamos las edges
        // draw edges
        Enumeration enumAristas = edges.elements();
		while (enumAristas.hasMoreElements()){
			Item i = (Item) enumAristas.nextElement();
			int pos = i.getPosition();
			if (pos!=1 && pos!=4)
				i.paint(g);
		}
		enumAristas = edges.elements();
		while (enumAristas.hasMoreElements()){
			Item i = (Item) enumAristas.nextElement();
			int pos = i.getPosition();
			if (pos==1 || pos==4)
				i.paint(g);
		}
		enumAristas=null;

        // draw verticies
        // dibujamos los vrtices
		Enumeration enumVertices = vertices.elements();
		while (enumVertices.hasMoreElements()){
			Item i = (Item) enumVertices.nextElement();
			i.paint(g);
		}
		enumVertices=null;

	}

    public void paint(Graphics g){
		g.drawImage(buffImg,bounds.x,bounds.y,0);
	}

    public void Move(int x, int y){
		Rectangle rClip=new Rectangle(0,0,getWidth(), getHeight());
		bounds.Move(x,y);
		if (!bounds.inside(rClip))
			bounds.Move(-x,-y);
	}

    // operations on tokens on the board
    // Operaciones para aadir fichas al tablero
	public void addCity(int c, int r, int pos, int[] color){
		Coordinate coor = new Coordinate(c,r,pos);
		coor.translVertice();
		Point p = new Point(map.getPoint(coor.c,coor.r));
		City ci = new City(p.x,p.y,map.getSize(),coor.pos,color);
		vertices.put(coor,ci);
		ci.paint(buffGraphics);
	}

	public void addSettlement(int c, int r, int pos, int[] color){
		Coordinate coor = new Coordinate(c,r,pos);
		coor.translVertice();
		Point p = new Point(map.getPoint(coor.c,coor.r));
		Settlement pob = new Settlement(p.x,p.y,map.getSize(),coor.pos,color);
		vertices.put(coor,pob);
		pob.paint(buffGraphics);
	}

	public void addRoad(int c, int r, int pos, int[] color){
		Coordinate coor = new Coordinate(c,r,pos);
		coor.translEdge();
		Point p = new Point(map.getPoint(coor.c,coor.r));
		Road k = new Road(p.x,p.y,map.getSize(),coor.pos,color);
		edges.put(coor,k);
		paint(buffGraphics);
	}

	public void addShip(int c, int r, int pos, int[] color){
		Coordinate coor = new Coordinate(c,r,pos);
		coor.translEdge();
		Point p = new Point(map.getPoint(coor.c,coor.r));
		Ship b = new Ship(p.x,p.y,map.getSize(),coor.pos,color);
		edges.put(coor,b);
		paint(buffGraphics);
	}

	public boolean isEdgeEmpty(Coordinate c){
		return isEdgeEmpty(c.c,c.r,c.pos);
	}
	public boolean isEdgeEmpty(int c, int r, int pos){
		Coordinate coor = new Coordinate(c,r,pos);
		coor.translEdge();
		return edges.get(coor)==null;
	}

	public Item getEdge(int c, int r, int pos){
		return getEdge(new Coordinate(c,r,pos));
	}
	public Item getEdge(Coordinate coor){
		coor.translEdge();
		return (Item) edges.get(coor);
	}

	public boolean isVerticeEmpty(Coordinate c){
		return isVerticeEmpty(c.c,c.r,c.pos);
	}
	public boolean isVerticeEmpty(int c, int r, int pos){
		Coordinate coor = new Coordinate(c,r,pos);
		coor.translVertice();
		return vertices.get(coor)==null;
	}

	public Item getVertice(int c, int r, int pos){
		return getVertice(new Coordinate(c,r,pos));
	}
	public Item getVertice(Coordinate coor){
		coor.translVertice();
		return (Item) vertices.get(coor);

	}

	// true si se ha podido mover                  // true if able to move there
	public boolean moveRobber(int c, int r){
		Field fld = map.getField(c,r);
//		try{
			if (fld instanceof Desert){// getClass() == Class.forName("Desert")){
				return false;
			}else{
				if (fld instanceof Water){//.getClass() == Class.forName("Water")){
					if (hasRobber(c,r)){
						return false;
					}else{
						pirata.setLocation(fld.getLocation());
						isPirata = true;
					}
				}else{
					if (hasRobber(c,r)){
						return false;
					}else{
						Terrain t = (Terrain) fld;
						robber.setValue(t.getValue());
						robber.setLocation(fld.getLocation());
						isRobber = true;
					}
				}
				paint(buffGraphics);
				return true;
			}
//		}catch(ClassNotFoundException e){
//			return false;
//		}
	}

	public boolean hasRobber(int c, int r){
		Point p = map.getPoint(c,r);
		return (isRobber && robber.getLocation().equals(p)) ||
			   (isPirata && pirata.getLocation().equals(p));
	}

	public void setBig(){           //todo not used
		map.setBig();
	}

	public void setSmall(){     //todo not used
		map.setSmall();
	}

	public Enumeration getAllCoorVertices(){
		return vertices.keys();
	}

	public Coordinate[] getContiguosVertice(Coordinate c){
		// las coordenadas de las fields
		Coordinate[] coor = new Coordinate[3];
		coor[0]=new Coordinate(c.c,c.r,(c.pos+5)%6);
		coor[1]=new Coordinate(c.c,c.r,c.pos).getAdjacentFieldEdge();
		coor[2]=coor[0].getAdjacentFieldEdge();

		return coor;
	}

	// value 0 si no hay value.           // value 0 if there is no value.
	public int[][] getValoresRecursosVertice(Coordinate c){
		Coordinate[] coor = getContiguosVertice(c);
		int[][] ret = new int[3][2];
		for (int i=0;i<3;i++){
			ret[i][0]=0;
			Field k = map.getField(coor[i].c,coor[i].r);
			if (!hasRobber(coor[i].c,coor[i].r)){
//				try{
					if (k instanceof Terrain){//.getClass() == Class.forName("Terrain")){
						Terrain t = (Terrain) k;
						ret[i][0]=t.getValue();
						ret[i][1]=t.getResource();
					}
//				}catch (ClassNotFoundException e){}
			}
		}
		return ret;
	}
}
