package com.jah0wl.catan;

//import com.nokia.mid.ui.*;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.Canvas;

import com.jah0wl.utils.*;
import com.jah0wl.catan.fields.*;

class MapOfCatan extends Canvas {
//class MapOfCatan extends FullCanvas{

    // transfer of the coordinate and to draw map in two pieces
    // traslado de la coordenada y para dibujar el map en dos
        // cachos
        public final static int yTranslation = -15;


    // tamao(?size) of the radius with which each hexagon was drawn
    // tamao del radio con el que se dibujara cada hexagono
    private final static int BIG_SIZE = 15;
    private final static int SMALL_SIZE = 8;
    private int size = SMALL_SIZE;

    private int rows;	// numero de filas
    private int cols;	// numero de columnas

    // Location of map in the screen
    // Localizacion del map en la pantalla
    Rectangle bounds; //=bounds of buffImg

    // Fields
    // Casillas!!
    private Field[][] fields;

    // Imagen del map
    // map image & its graphics
    private Image buffImg;
    private Graphics buffGraph;
//!!
//	private DirectGraphics buffDirectGraph;

    // pruebas          //tests
    private final static int MAX_COL_HEX = 8;
    private final static int MAX_ROW_HEX = 4;
    private final static int[] nums = {2,3,4,5,6,8,9,10,11,12};

    // constructor
    public MapOfCatan(String s){

// we opened the file with map. // We drew map in bufer
        // abrimos el fichero con el map
        LoadMap(s);

        // Inicializamos las imagenes
        buffImg = Image.createImage(bounds.width, bounds.height);
        buffGraph = buffImg.getGraphics();

        // Dibujamos el map en el bufer
        // Draw map to buffer
        paintIt(buffGraph);
    }

    private void LoadMap(String s){
        // aqui hay q leer el fichero y sacar toda la info
// is q here to read the file and to remove all info
        //
        //FileReader f = new FileReader(s);
        //char c;
        //String buff = "";
        //while(c=f.read()){
        // 	buff+=c;
        //}
        int firstX=-2;
        int firstY=6;

        cols=MAX_COL_HEX;
        rows=MAX_ROW_HEX;

        fields = new Field[cols+2][rows+2];

        int r = Random.random(2)+2;
        for (int y=0;y<=rows+1;y++){
            for (int x=0;x<=cols+1;x++){
                int cx,cy;
                if (x==0){
                    cx=firstX;
                    if (y==0){
                        cy=firstY;
                    }else{
                        cy=fields[x][y-1].y+
                           2*(fields[x][y-1].getPoint(2).y-fields[x][y-1].y);
                    }
                }else
                if (x%2==0){
                        //par
                        cx=fields[x-1][y].getPoint(1).x+size;
                        cy=fields[x-1][y].getPoint(1).y;
                }else{
                        //impar
                        cx=fields[x-1][y].getPoint(5).x+size;
                        cy=fields[x-1][y].getPoint(5).y;
                }
                if (x==0 || y==0 || x==cols+1 || y==rows+1)
                    fields[x][y] = new Water(cx,cy,size);
                else{
                    if ((x%r==0 || y%r==0) && (x==1 || y==1 || x==7 || y==5 )){
                        int posi;
                        if (x==1)
                            posi=(Random.random(2)+4)%6;
                        else if (y==1)
                            posi=Random.random(3)%3;
                        else if (x==7)
                            posi=Random.random(2)+1;
                        else
                            posi=Random.random(3)+2;
                        fields[x][y] = new Water(cx,cy,size,Random.random(6)%6,posi);
                    }else
                        fields[x][y] = new Terrain(cx,cy,size,Random.random(6)%6,nums[Random.random(10)%10]);
                }

            }
        }

        bounds = new Rectangle();
        bounds.union(fields[cols][1].getBounds());
        if (cols<=1)
            bounds.union(fields[1][rows].getBounds());
        else
            bounds.union(fields[2][rows].getBounds());
        bounds.width+=size;
        bounds.height+=size;
    }

    public void Move(int x, int y){
        bounds.Move(x,y);
    }

    public int getSize(){
        return size;
    }

    public void setBig(){
        this.size=BIG_SIZE;
    }

    public void setSmall(){
        this.size=SMALL_SIZE;
    }

    public boolean isBig(){
        return (size==BIG_SIZE);
    }

    public int getCols(){
        return cols;
    }

    public int getRows(){
        return rows;
    }

    public Point getPoint(int c, int r){
        return fields[c][r].getLocation();
    }

    public Point getPoint(int c, int r, int vertice){
        return fields[c][r].getPoint(vertice);
    }

    public Field getField(int c, int r){
        return fields[c][r];
    }

    private void paintIt(Graphics g){
        for (int y=0;y<=rows+1;y++)
            for (int x=0;x<=cols+1;x++){
                fields[x][y].paint(g);
            }
    }

        public void paint(Graphics g){
           g.drawImage(buffImg,bounds.x,bounds.y,0);
        }

    public Rectangle getBounds(){
        return new Rectangle(bounds);
    }
}
