package com.jah0wl.catan;

import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.Font;
import java.io.IOException;
import com.jah0wl.utils.Point;

//! player setup canvas -- shown at startup
class PlayersCanvas extends GameCanvas{
	
	private static Image background;
	
	public final static int HUMANO = 0;
	public final static int NO_PLAYER = 1;
	public final static int MACHINE = 2;

	private static Image image;
	
	private int[] selects = new int[4];
	
	private Point[] rSelection = {new Point(32,5), new Point(32,23),
								  new Point(32,41), new Point(32,59)};
	
	private int[][] colours = {Player.GOLD,Player.CIAN,
							   Player.RED,Player.GREEN};
	
	private int current = 0;
	
	private boolean isError = false;
	
	public PlayersCanvas( Catan m ){
		super(m);
		
		try{
			background = Image.createImage("/players.png");
			image = Image.createImage("/sel_player.png");
		}catch(IOException e){}
		for (int i=0;i<4;i++)
			selects[i]=HUMANO;	
	}
	
	public void paint(Graphics g){
		// draw background
		g.drawImage(background,0,0,g.TOP|g.LEFT);
		
		// draw selected types images
		for (int i=0;i<4;i++){
			g.setClip(rSelection[i].x+2,rSelection[i].y+2,60,11);
			g.drawImage(image,rSelection[i].x+2,rSelection[i].y+2-(11*selects[i]),g.TOP|g.LEFT);		
		}
		g.setClip(0,0,getWidth(),getHeight());

		// draw selection rectangle //dibujamos el rectangulo del seleccionado
		g.setColor(0,0,0);		
		g.setStrokeStyle(g.DOTTED);
		g.drawRect(rSelection[current].x,rSelection[current].y,64,15);
		if (isError){
			// no se han elegido los players oportunos
            // has not chosen players opportune
            g.setColor(255,255,255);
			g.fillRect(13,13,73,70);
			g.setStrokeStyle(g.DOTTED);
			g.setColor(0,0,0);					
			g.drawRect(14,14,71,70);
			g.setFont(Font.getFont(Font.FACE_PROPORTIONAL,Font.STYLE_PLAIN,Font.SIZE_SMALL));
			g.drawString("Please select",15,31,0);
			g.drawString("more than 1",15,46,0);
			g.drawString("player",15,61,0);
//			g.drawString("Debe elegir",getWidth()/2-g.getFont().stringWidth("Debe elegir")/2,31,0);
//			g.drawString("ms de 1",getWidth()/2-g.getFont().stringWidth("ms de 1")/2,46,0);
//			g.drawString("jugador",getWidth()/2-g.getFont().stringWidth("jugador")/2,61,0);
			isError=true;
		}
	}

	public void keyPressed(int k){
		if (isError){
			isError=false;
		}else{
			if (k == this.downKey){
				current =(current +1)%4;
			}else if (k == this.upKey){
				current =(current +(4-1))%4;
			}else if (k == this.leftKey){
				selects[current]=(selects[current]+(2-1))%2;
			}else if (k == this.rightKey){
				selects[current]=(selects[current]+1)%2;
			}else if (k == this.fireKey){//.KEY_SOFTKEY1){ //OK
				midlet.commandAction(midlet.okCommand,this);
//			}else if (k == this.KEY_SOFTKEY2){ //EXIT
//				midlet.commandAction(midlet.exitCommand,this);
			}
		}
		repaint();
	}
	
	public int getNumJugadores(){
		int n = 0;
		for (int i=0;i<4;i++)
			n += (selects[i]==HUMANO)?1:0;
		return n;
	}
	
	public int[] getColorJugador(int index){
		return (selects[index]==HUMANO)?colours[index]:null;
	}
	
	public void showErrorNumJugadores(){
		isError=true;	
		repaint();
	}
	
}